#include <stdio.h>
#include <stdlib.h>

// Modification of capitalize.c to
// show that pointers themselves are passed
// by value. So assigning a pointer inside
// a function will not change the caller's argument.

static char cap_diff = 'a'-'A';

/* makes a string uppercase, in place
 */
void capitalize(char* s) {
  while (*s != '\0') {
    if (*s < 'a' || *s > 'z') {
      fprintf(stderr, "only works on lowercase letters\n");
      exit(2);
    }
    *s -= cap_diff;
    ++s;
  }
}

/* takes a lowercase string of ascii characters
 * and prints it in uppercase
 */
int main(int argc, char** argv) {
  if (argc != 2) {
    fprintf(stderr, "usage: %s STRING\n", argv[0]);
    exit(1);
  }

  char* str = argv[1];

  printf("Input: %s\n", str);
  printf("&argv[1] before: %p\n", str);
  capitalize(str);
  printf("Output: %s\n", str);
  printf("&argv[1] after:  %p\n", str);
}
